跳转到主要内容

Data Binding & State Management in Angular Scheduler

Angular Scheduler supports two data ownership models:

  1. Angular state as the source of truth (recommended for most applications).
  2. Scheduler as the source of truth (performance-focused for specialized pages).

Choose one model per page/feature area and keep it consistent.

Angular State Or Store As Source Of Truth

In this model:

  • your component state or RxJS store owns events.
  • the wrapper receives arrays through inputs.
  • chart changes are captured via data.save or data.batchSave.
  • callbacks update your state/store and new arrays flow back into <dhx-scheduler>.

Best for

  • Angular pages with toolbars/forms that must stay in sync with the chart.
  • team codebases already built around services and RxJS.
  • predictable state transitions and easier debugging.

Tradeoffs

  • more application-state updates for heavy scheduler operations.
  • more frequent synchronization work during bulk edits.

Anti-patterns to avoid

  • mutating data through instance while still pushing stale events array from Angular state.
  • ignoring data.save / data.batchSave and expecting scheduler edits to persist in your app state automatically.

Full-flow example (component state)

import { Component } from "@angular/core";
import {
DhxSchedulerComponent,
type AngularSchedulerDataConfig,
type Event,
} from "@dhtmlx/trial-angular-scheduler";

@Component({
selector: "app-scheduler",
standalone: true,
imports: [DhxSchedulerComponent],
template: `<dhx-scheduler [events]="events" [data]="dataConfig"></dhx-scheduler>`,
})
export class SchedulerComponent {
events: Event[] = [
{
id: 1,
text: "Planning",
start_date: new Date("2026-05-18T09:00:00"),
end_date: new Date("2026-05-18T10:30:00"),
},
];

dataConfig: AngularSchedulerDataConfig = {
save: (entity, action, item, id) => {
if (entity !== "event") return;

if (action === "create") {
this.events = [...this.events, item as Event];
return;
}

if (action === "update") {
this.events = this.events.map(event =>
String(event.id) === String(id) ? { ...(item as Event) } : event
);
return;
}

if (action === "delete") {
this.events = this.events.filter(event => String(event.id) !== String(id));
}
},
};
}

Scheduler As Source Of Truth

In this model, the chart and backend own most of the runtime data lifecycle.

Best for

  • very large datasets.
  • scheduler-centric screens.
  • heavy or chained edits where frequent app-store updates are expensive.

Tradeoffs

  • less immediate visibility of live chart state in Angular services/components.
  • extra discipline required when mixing occasional input updates with imperative operations.

Anti-patterns to avoid

  • partial mirroring without a clear reconciliation plan.
  • refeeding stale server snapshots after users already changed data in the chart.

Server transport example

dataConfig = {
save: async (entity: string, action: string, item: any, id: string | number) => {
if (entity !== "event") return;

if (action === "create") {
const response = await fetch("/api/events", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});

const created = await response.json();
return { id: created.id };
}

if (action === "update") {
await fetch(`/api/events/${id}`, {
method: "PUT",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});
return;
}

if (action === "delete") {
await fetch(`/api/events/${id}`, { method: "DELETE" });
}
},
};

If your backend replaces temporary IDs on create, return { id: realId } so Scheduler can reconcile client and server IDs.

Callback Contracts

data.save

save is passed to scheduler.createDataProcessor(save) and receives per-change payloads.

Typical function shape:

(entity: string, action: string, data: any, id: string | number) => any

For Scheduler event CRUD:

  • entity is "event",
  • action is "create" | "update" | "delete",
  • data is the created, updated, or deleted event,
  • id is the affected event id.

Bulk updates with data.batchSave

data.batchSave is useful when many changes are emitted in a short time.

Use it when you want to:

  • reduce request count by sending grouped changes.
  • process updates in one reducer or store transaction.
dataConfig = {
batchSave: async changes => {
await fetch("/api/events/batch", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(changes),
});
},
};

Use save for simple per-change logic, and batchSave for grouped synchronization.

Loading Data Into Angular State

In the Angular-driven model, Scheduler gets data from Angular state. Common sources:

  • local component fields,
  • service state,
  • RxJS store,
  • API calls.

Local state source

events: Event[] = seedEvents;
date = new Date("2026-05-18T00:00:00");
view = "week";
<dhx-scheduler [events]="events" [date]="date" [view]="view"></dhx-scheduler>

RxJS store source

Every store follows the same flow:

  • observable reads state,
  • AsyncPipe unwraps a view model,
  • inputs feed Scheduler,
  • data.save or data.batchSave calls store methods.
@if (vm$ | async; as vm) {
<dhx-scheduler
[events]="vm.events"
[date]="vm.date"
[view]="vm.view"
[data]="dataConfig">
</dhx-scheduler>
}

See Using Angular Scheduler with RxJS for a complete example.

API loading source

async ngOnInit(): Promise<void> {
const response = await fetch("/api/events");
const payload = await response.json();
this.events = payload.events || [];
}

When Angular owns the data, prefer loading into Angular state and passing events to the wrapper.

Scheduler As Source Of Truth

In this mode, Angular renders the component but does not hold canonical event state.

URL transport example

<dhx-scheduler
[data]="{
load: '/api/scheduler/load',
save: '/api/scheduler/save'
}">
</dhx-scheduler>

Callback transport example

dataConfig = {
load: async () => {
const response = await fetch("/api/scheduler/load");
return response.json();
},
save: async (entity, action, item, id) => {
await fetch("/api/scheduler/save", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify({ entity, action, item, id }),
});
},
};

Use this approach when Scheduler can remain the primary runtime store and Angular does not need to render every individual update.

What's Next

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

跳转到主要内容

Data Binding & State Management in Vue Scheduler

This guide helps you choose where your app owns Scheduler data and how to keep events edits synchronized. Pick one ownership model per page and keep it consistent.

Vue Scheduler supports two common models:

  1. Vue state/store as source of truth (best default for most apps)
  2. Scheduler as source of truth (performance-focused for chart-heavy pages)

Mental Model

The wrapper syncs props into a live Scheduler instance. If users edit events, you decide whether:

  • the wrapper callback updates Vue state (Vue-owned model), or
  • the scheduler/backend handles changes directly (Scheduler-owned model)

The main pitfall is mixed ownership. If Vue and the Scheduler instance both act like the source of truth, stale data overwrites are likely.

Vue State Or Store As Source Of Truth

In this model:

  • Vue state (or as an example Pinia) owns events
  • the wrapper receives arrays through props
  • scheduler edits are captured via data.save or data.batchSave
  • callback handlers update state
  • updated state flows back into the wrapper

Best For

  • pages with surrounding Vue UI that must reflect scheduler state
  • apps that already use Pinia or a centralized state layer
  • teams that want predictable unidirectional data flow

Tradeoffs

  • more application-state updates for heavy operations
  • more sync work when many edits happen in one scheduler action

Avoid These Patterns

  • mutating data through instance while continuing to pass stale arrays from Vue state
  • ignoring wrapper callbacks and expecting scheduler edits to persist in Vue state automatically

Example: Store/Vue-Owned Flow

<script setup lang="ts">
import { ref } from "vue";
import VueScheduler, {
type VueSchedulerDataConfig
} from "@dhtmlx/trial-vue-scheduler";

const events = ref<SerializedEvent[]>([]);

const data: VueSchedulerDataConfig = {
save: (entity, action, item, id) => {
if (entity === "event") {
if (action === "create") events.value = [...events.value, item as Event];
if (action === "update") events.value = events.value.map(t => String(t.id) === String(id) ? item as Event : t);
if (action === "delete") events.value = events.value.filter(t => String(t.id) !== String(id));
}
}
};
</script>

<template>
<VueScheduler :events="events" :data="data" />
</template>

For multi-change operations, move to data.batchSave and apply changes in grouped batches.

Scheduler As Source Of Truth

In this model, the scheduler and backend own most data lifecycle operations. Vue does less live mirroring.

Best For

  • very large datasets
  • bulk update flows
  • scheduler-focused pages where external UI does not need every live change immediately

Tradeoffs

  • less visibility of live scheduler state in Vue state/store
  • more discipline required if you occasionally push prop snapshots back into the wrapper

Avoid These Patterns

  • partial Vue mirroring without a reconciliation strategy
  • refeeding stale server snapshots after users edit the scheduler

Example: Scheduler-Owned Transport

<script setup lang="ts">
import VueScheduler from "@dhtmlx/trial-vue-scheduler";

const data = {
load: "/api/scheduler/load",
save: async (entity: string, action: string, payload: any, id: string | number) => {
const response = await fetch(`/api/scheduler/${entity}`, {
method: action === "delete" ? "DELETE" : "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify({ action, payload, id })
});

// Create handlers should return the persistent ID when backend remaps it.
return await response.json();
}
};
</script>

<template>
<VueScheduler :data="data" />
</template>

Callback Contracts

This section covers the wrapper callback shapes you use in both ownership models.

data.save

save is passed to scheduler.createDataProcessor(save) and receives one change at a time.

Typical function shape:

(entity: string, action: string, data: any, id: string | number) => any

Use this when changes are mostly singular and easy to process one by one.

data.batchSave

batchSave receives changes grouped into events:

interface BatchChanges {
events?: DataCallbackChange[];
}

Summary:

  • near-term flush batching
  • create + update can be coalesced into one create with the latest payload
  • create + delete can be removed from the batch
  • internal !nativeeditor_status is stripped from payloads

Use this when one user action can produce many updates.

ID Remapping And Backend Responsibility

Create actions often start with temporary client-side IDs.

  • In save mode, backend responses should return persistent IDs so Scheduler can remap records.
  • In batchSave mode, there is no per-item return path. If the server assigns IDs, handle remapping explicitly in your persistence workflow.

Backend responsibilities stay the same in both modes:

  • validate incoming payloads
  • enforce permissions
  • persist authoritative IDs
  • return data structures your selected transport mode expects
Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

跳转到主要内容

Data Binding & State Management in React Scheduler

React Scheduler supports two data binding patterns:

  1. React state as the source of truth (recommended for most React apps)
  2. Scheduler as the source of truth (useful for specialized, high-throughput cases)

Both models are valid. Pick one model per screen and keep it consistent.

If you have not rendered a basic chart yet, start with Quick Start.

Data models

In this model:

  • you keep events (and often view / date) in React state or a state manager
  • you pass that state into <ReactScheduler /> props
  • Scheduler calls data.save / data.batchSave when users edit data
  • you update state, and React re-renders Scheduler with the new props

Use this when other React components must stay synchronized with Scheduler data.

Scheduler as the source of truth

In this model:

  • Scheduler loads and mutates data internally
  • you optionally forward edits to backend endpoints
  • React does not mirror every event update in state

Use this model when React does not need to immediately reflect every individual Scheduler change.

React state as source of truth

Minimal example

import { useMemo, useState } from "react";
import ReactScheduler, { type Event } from "@dhtmlx/trial-react-scheduler";
import "@dhtmlx/trial-react-scheduler/dist/react-scheduler.css";

import { seedEvents } from "./seed/data";

export default function ReactStateScheduler() {
const [events, setEvents] = useState<Event[]>(seedEvents);

const data = useMemo(
() => ({
save: (entity: string, action: string, item: Event, id: string | number) => {
if (entity !== "event") return;

if (action === "create") {
setEvents((prev) => [...prev, item]);
return;
}

if (action === "update") {
setEvents((prev) => prev.map((e) => (e.id === id ? item : e)));
return;
}

if (action === "delete") {
setEvents((prev) => prev.filter((e) => e.id !== id));
}
},
}),
[]
);

return (
<div style={{ height: "100vh" }}>
<ReactScheduler events={events} data={data} />
</div>
);
}

This pattern makes React the canonical owner of event data.

Handling updates with data.save

data.save is called for each user change:

(entity: string, action: string, item: any, id: string | number) => void | Promise<any>

For Scheduler event CRUD:

  • entity is "event"
  • action is "create" | "update" | "delete"
  • item is the created/updated/deleted event
  • id is the affected event id

Backend-oriented example

const data = {
save: async (entity: string, action: string, item: any, id: string | number) => {
if (entity !== "event") return;

if (action === "create") {
const response = await fetch("/api/events", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});

const created = await response.json();
return { id: created.id };
}

if (action === "update") {
await fetch(`/api/events/${id}`, {
method: "PUT",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(item),
});
return;
}

if (action === "delete") {
await fetch(`/api/events/${id}`, { method: "DELETE" });
}
},
};

If your backend replaces temporary IDs on create, return { id: realId } so Scheduler can reconcile client and server IDs.

Bulk updates with data.batchSave

data.batchSave is useful when many changes are emitted in a short time (for example, dense editing sessions).

Use it when you want to:

  • reduce request count by sending grouped changes
  • process updates in one reducer/store transaction
<ReactScheduler
events={events}
data={{
batchSave: async (changes) => {
await fetch("/api/events/batch", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify(changes),
});
},
}}
/>

Use save for simple per-change logic, and batchSave for grouped synchronization.

Loading data into React state

In the React-driven model, Scheduler gets data from React state. Common sources:

  • local component state
  • global state manager (Redux Toolkit, Zustand, MobX, XState, Jotai, Valtio)
  • API calls

Local state source

import { useState } from "react";
import ReactScheduler, { type Event } from "@dhtmlx/trial-react-scheduler";
import { seedEvents, seedView, seedDate } from "./seed/data";

export default function LocalStateExample() {
const [events] = useState<Event[]>(seedEvents);

return (
<ReactScheduler
events={events}
view={seedView}
date={seedDate}
/>
);
}

State manager source

Every library follows the same flow:

  • selector/hook reads state
  • props feed Scheduler
  • data.save dispatches actions/store mutations
const events = useSchedulerStore((s) => s.events);
const onSave = useSchedulerStore((s) => s.handleSave);

<ReactScheduler events={events} data={{ save: onSave }} />;

State-manager tutorials:

API loading source

import { useEffect, useState } from "react";
import ReactScheduler, { type Event } from "@dhtmlx/trial-react-scheduler";

export default function SchedulerWithApi() {
const [events, setEvents] = useState<Event[] | null>(null);

useEffect(() => {
let disposed = false;

(async () => {
const response = await fetch("/api/events");
const payload = await response.json();
if (!disposed) setEvents(payload.events || []);
})();

return () => {
disposed = true;
};
}, []);

if (!events) return <div>Loading Scheduler...</div>;

return <ReactScheduler events={events} />;
}

Scheduler as source of truth

In this mode, React renders the component but does not hold canonical event state.

URL transport example

<ReactScheduler
data={{
load: "/api/scheduler/load",
save: "/api/scheduler/save",
}}
/>

Callback transport example

<ReactScheduler
data={{
load: async () => {
const response = await fetch("/api/scheduler/load");
return response.json();
},
save: async (entity, action, item, id) => {
await fetch("/api/scheduler/save", {
method: "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify({ entity, action, item, id }),
});
},
}}
/>

Use this approach when Scheduler can remain the primary runtime store and React does not need to render every single update.

Choosing the right model

Use React-driven model when:

  • multiple React components depend on Scheduler data
  • you need predictable global state integration
  • you want straightforward undo/redo in app state

Use Scheduler-driven model when:

  • React is mostly shell/layout
  • you prefer Scheduler-managed runtime mutations
  • server transport is the primary synchronization mechanism

What's next

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.